Type.registerNamespace("Telerik.Web.UI");
Telerik.Web.UI.DockMode=function(){
throw Error.notImplemented();
};
Telerik.Web.UI.DockMode.prototype={Floating:1,Docked:2,Default:3};
Telerik.Web.UI.DockMode.registerEnum("Telerik.Web.UI.DockMode");
Telerik.Web.UI.RadDock=function(_1){
Telerik.Web.UI.RadDock.initializeBase(this,[_1]);
this._initialized=false;
this._enableDrag=true;
this._top=0;
this._left=0;
this._autoPostBack=false;
this._dockZoneID=null;
this._title=null;
this._commands=null;
this._closed=false;
this._collapsed=false;
this._pinned=false;
this._index=0;
this._forbiddenZones=[];
this._layoutID=null;
this._handle=null;
this._dockMode=Telerik.Web.UI.DockMode.Default;
this._resizable=false;
this._width="300px";
this._height=null;
this._expandedHeight=0;
this._uniqueID=null;
this._uniqueName=null;
this._grip=null;
this._titleBar=null;
this._commandsContainer=null;
this._contentContainer=null;
this._handle=null;
this._form=null;
this._skin="Default";
this.set_handle=this.set_handle;
this._isCustomHandle=false;
};
Telerik.Web.UI.RadDock.DragDataType="RadDock";
Telerik.Web.UI.RadDock.prototype={_fixIeHeight:function(_2,_3){
if("CSS1Compat"==document.compatMode){
var _4=(_2.offsetHeight-parseInt(_3));
if(_4>0){
var _5=(parseInt(_2.style.height)-_4);
if(_5>0){
_2.style.height=_5+"px";
}
}
}
},_getTopElement:function(){
var _6=null;
var _7=this.get_titleBar();
if(_7){
_6=_7;
}else{
if(this._grip){
_6=this._grip;
}
}
return _6;
},_isDockRightToLeft:function(){
var _8=this._isRightToLeft;
if(_8==null){
var _9=this.get_element();
if(_9){
_8=this._isRightToLeft=$telerik.isRightToLeft(_9);
}
}
return _8;
},_setResizeLimit:function(){
var _a=0;
var _b=this._getTopElement();
var _c=0;
if(_b){
var _d=$telerik.getBounds(_b);
_a+=_d.height;
}
var _e=this._calculateResizeHandlesSize();
var _f=this.get_element();
this._minHeight=_a+_e.horizontalHeight;
_f.style.minHeight=this._minHeight+"px";
this.get_innerDockElement().style.minHeight=_a+"px";
var _10=this.get_commandsContainer();
var _11=1+_e.verticalWidth;
var _12=_10?$telerik.getBounds(_10).width:0;
var _13=this.get_titleElement();
var _14=_13?$telerik.getMarginBox(_13).horizontal:0;
_11+=_12+_14;
this._minWidth=_11;
_f.style.minWidth=_11+"px";
},_calculateResizeHandlesSize:function(){
if(!this._tableElement){
return null;
}
var _15=this._tableElement.rows;
var _16={n:$telerik.getBounds(_15[0].cells[1]),w:$telerik.getBounds(_15[1].cells[0]),e:$telerik.getBounds(_15[1].cells[2]),s:$telerik.getBounds(_15[2].cells[1])};
var _17={horizontalHeight:_16.n.height+_16.s.height,verticalWidth:_16.w.width+_16.e.width};
return _17;
},_collapseWrapper:function(){
var _18=this._tableElement;
if(_18){
var _19=this.get_contentContainer();
var _1a=$telerik.getBounds(_19);
var _1b=parseInt(_18.style.height)-_1a.height;
_18.style.height=(_1b>0?_1b:0)+"px";
}
},_removeWrapper:function(){
var _1c=this._tableElement;
if(_1c){
var _1d=this._calculateResizeHandlesSize();
var _1e=this.get_element();
var _1f=this.get_innerDockElement();
var _20=this.get_topBorderElement();
var _21=this.get_bottomBorderElement();
_1e.removeChild(_1c);
this._tableElement=null;
_1e.appendChild(_1f);
_1e.appendChild(_20);
_1e.appendChild(_21);
_1f.style.width="100%";
_1f.style.height="100%";
this._fixTableLayoutSize(this._width,this._height);
}
},_updateSizeValues:function(){
var _22=this._getBounds();
this._width=_22.width;
this._height=_22.height;
},_setWidthHtmlEl:function(_23,_24){
if(!_23){
return;
}
if(!_24){
_24=this.get_element();
}
if(_23.toString().indexOf("%")>-1){
_24.style.width=parseInt(_23)+"%";
}else{
_24.style.width=parseInt(_23)+"px";
}
},_setHeightHtmlEl:function(_25,_26){
if(!_26){
_26=this.get_element();
}
if(!_25){
_26.style.height="";
return;
}
if(_25.toString().indexOf("%")>-1){
_26.style.height=parseInt(_25)+"%";
}else{
_26.style.height=parseInt(_25)+"px";
}
},_moveElements:function(_27,_28){
while(_27.childNodes&&_27.childNodes.length>0){
var _29=_27.childNodes[0];
_27.removeChild(_29);
_28.appendChild(_29);
}
},_configureHandles:function(_2a){
if(!this._tableElement){
return;
}
var _2b=["e","s","se"];
var _2c=this._resizeExtender._resizeHandles;
for(var i=0;i<_2b.length;i++){
var _2e=_2b[i];
var _2f=_2c[_2e];
if(_2f){
_2f.style.cursor=_2a?_2e+"-resize":"";
}
}
},_getFullSkinName:function(){
return " raddock RadDock_"+this._skin+" rdVariableHeight";
},_createResizeWrapper:function(){
var _30=document.createElement("TABLE");
_30.id=this.get_id()+"Table";
_30.className="rdWrapTable";
_30.width="100%";
_30.height="100%";
_30.cellSpacing=0;
_30.cellPadding=0;
this._tableElement=_30;
var _31=["rdTopLeft","rdTopCenter","rdTopRight","rdLeftMiddle","rdCenter","rdRightMiddle","rdBottomLeft","rdBottomCenter","rdBottomRight"];
var _32=0;
for(var i=0;i<3;i++){
var row=_30.insertRow(-1);
for(var j=0;j<3;j++){
var _36=row.insertCell(-1);
_36.innerHTML="&nbsp;";
_36.className=_31[_32];
_32++;
}
}
return _30;
},_fixEmWidth:function(){
if(!this.get_titleBar()){
return;
}
var _37=$telerik.getBounds(this.get_innerDockElement()).width;
var _38=this.get_commandsContainer();
var _39=_38?$telerik.getBounds(_38).width:0;
var _3a=this.get_titleElement();
if(_3a){
var _3b=_37-_39-$telerik.getMarginBox(_3a).horizontal;
if($telerik.isSafari){
_3b=_37-_39-30;
}
var _3c=_3b>0?_3b:0;
this._setWidthHtmlEl(_3c,_3a);
}
},_enableMoveResize:function(){
if(this._resizeExtender){
this._resizeExtender.dispose();
}
var _3d={};
if(this._resizable){
var _3e=this.get_element();
if(!this._tableElement){
var _3f=this._createResizeWrapper();
var _40=_3f.rows[1].cells[1];
_40.innerHTML="";
this._moveElements(_3e,_40);
_3e.appendChild(_3f);
}
var _41=this._tableElement.rows;
if(this._isDockRightToLeft()){
_3d={e:_41[1].cells[0],s:_41[2].cells[1],se:_41[2].cells[0]};
}else{
_3d={e:_41[1].cells[2],s:_41[2].cells[1],se:_41[2].cells[2]};
}
}else{
this._removeWrapper();
}
if(this._handle&&this.get_enableDrag()&&!this.get_pinned()){
_3d["move"]=this._handle;
}
this._resizeExtender=new Telerik.Web.UI.ResizeExtender(this,this.get_element(),_3d,this._tableElement);
if(this._resizable){
this._setResizeLimit();
this._setSize();
if(this._collapsed||this._dockZoneID){
this._configureHandles(false);
}
}
},_makeResizable:function(){
this._enableMoveResize();
},onResizeStart:function(){
if(this._collapsed||this._dockZoneID){
return;
}
this.get_contentContainer().style.display="none";
this.raise_resizeStart(new Sys.EventArgs());
},onResizing:function(e){
if(this._collapsed||this._dockZoneID){
return false;
}
var _43=this.get_innerDockElement();
_43.style.display="none";
var _44=$telerik.getBounds(_43.parentNode).width;
_43.style.display="";
this._setWidthHtmlEl(_44,_43);
_43.style.width="auto";
this._fixEmWidth();
},onResizeEnd:function(){
if(this._collapsed||this._dockZoneID){
return;
}
var _45=this._getBounds();
var _46=_45.width;
var _47=_45.height;
if(_46<this._minWidth){
_46=this._minWidth;
}
if(_47<this._minHeight){
_47=this._minHeight;
}
this._setSize(_46,_47);
this._updateSizeValues();
this.updateClientState();
this.raise_resizeEnd(new Sys.EventArgs());
},_initializeDrag:function(){
if(this._handle){
this._disposeDrag();
if(this.get_enableDrag()&&!this.get_pinned()){
Sys.UI.DomElement.addCssClass(this._handle,"rdDraggable");
this._enableMoveResize();
}else{
if(this._resizable){
this._enableMoveResize();
}
}
}
},_disposeDrag:function(){
if(this._handle&&this._resizeExtender){
this._resizeExtender.dispose();
this._resizeExtender=null;
Sys.UI.DomElement.removeCssClass(this._handle,"rdDraggable");
}
},_startDragDrop:function(){
var _48=this.get_element();
this.originalZIndex=_48.style.zIndex;
var _49=this._getBounds(_48);
var _4a=this._getBorderBox(_48);
_49.width-=_4a.horizontal;
_49.height-=_4a.vertical;
_48.style.width=_49.width+"px";
_48.style.zIndex="9999999";
var _4b=$telerik.getLocation(_48);
if(_48.parentNode!=this._form){
this._form.appendChild(_48);
}
var _4c=$find(this.get_dockZoneID());
if(_4c){
_4c._showPlaceholder(this,_4b);
}
this._setLocation(_4b);
},onDragStart:function(){
if(!this.get_enableDrag()||this.get_pinned()){
return false;
}
this.get_contentContainer().style.overflow="hidden";
this._startDragDrop();
var _4d=this.get_element();
this.raise_dragStart(new Sys.EventArgs());
return true;
},onDrag:function(_4e){
this._hitZone=this.dockingZoneHitTest(_4e.ownerEvent);
this.raise_drag(new Sys.EventArgs());
},onDragEnd:function(_4f){
var _50=this._hitZone;
if(!_50){
var _51=this._getBounds();
_50=this._hitZone=this.dockingZoneHitTest(_4f.ownerEvent);
}
if(_50){
if(_50.canDrop(this)){
_50.drop(this);
}else{
this._restorePosition();
}
}else{
if(this.canDrop()){
this.drop();
}else{
this._restorePosition();
}
}
this.get_contentContainer().style.overflow="auto";
this.raise_dragEnd(new Sys.EventArgs());
},get_dockZones:function(){
if(typeof (Telerik.Web.UI.RadDockZonesGlobalArray)=="undefined"){
return [];
}
return Telerik.Web.UI.RadDockZonesGlobalArray;
},dockingZoneHitTest:function(e){
var _53;
var _54=null;
var _55=this.get_dockZones();
for(var i=0;i<_55.length;i++){
_53=_55[i];
if(_53.hitTest(this,e)){
_54=_53;
}
}
return _54;
},canDrop:function(){
return (this.get_dockMode()&Telerik.Web.UI.DockMode.Floating)>0;
},drop:function(){
var _57=new Sys.CancelEventArgs();
this.raise_dockPositionChanging(_57);
this.get_element().style.zIndex=this.originalZIndex;
if(_57.get_cancel()){
this._restorePosition();
}else{
this.undock();
this.raise_dockPositionChanged(new Sys.EventArgs());
}
},getCommand:function(_58){
return this._commands?this._commands[_58]:null;
},get_handle:function(){
return this._handle;
},set_handle:function(_59){
this._isCustomHandle=true;
this._setHandle(_59);
},_setHandle:function(_5a){
this._disposeDrag();
this._handle=_5a;
this._initializeDrag();
},_repaintHelper:function(){
if(this.get_closed()){
return;
}
if(this._resizable&&Sys.UI.DomElement.containsCssClass(this.get_element(),"rdVariableHeight")){
this.get_contentContainer().style.height="";
}else{
this._setContentContainerHeight();
}
this._setCommandsContainerWidth();
},getInvisibleParent:function(_5b){
while(_5b!=document){
if("none"==$telerik.getCurrentStyle(_5b,"display","")){
return _5b;
}
_5b=_5b.parentNode;
}
return null;
},subtractPoints:function(p1,p2){
return {x:p1.x-p2.x,y:p1.y-p2.y};
},addPoints:function(p1,p2){
return {x:p1.x+p2.x,y:p1.y+p2.y};
},initialize:function(){
Telerik.Web.UI.RadDock.callBaseMethod(this,"initialize");
if(this._isDockRightToLeft()){
Sys.UI.DomElement.addCssClass(this.get_element(),"raddock_rtl");
Sys.UI.DomElement.addCssClass(this.get_element(),"raddock_"+this._skin+"_rtl");
}
this._initializeHtmlElementVariables();
this._initializeCommands();
this._updateToggleCommandsState();
this._setPinUnpinVisibility();
this._setHandle(this._titleBar||this._grip);
var _60=this.get_commandsContainer();
this._commandsContainerWidth=_60?$telerik.getBounds(_60).width:0;
var _61=this.get_element();
var _62=_61.parentNode;
var _63=this.getInvisibleParent(this.get_element().parentNode);
isHidden=(_63!=null);
if(isHidden){
var _64={position:_61.style.position,top:_61.style.top,left:_61.style.left};
_61.parentNode.removeChild(_61);
_61.style.position="absolute";
_61.style.top="-5000px";
_61.style.left="-5000px";
document.body.appendChild(_61);
}
this._makeResizable();
this._setContentContainerHeight();
if(isHidden){
_61.style.position=_64.position;
_61.style.top=_64.top;
_61.style.left=_64.left;
_61.parentNode.removeChild(_61);
var _65=this.get_dockZone();
if(_65&&Telerik.Web.UI.RadDockZone.isInstanceOfType(_65)){
_62.insertBefore(_61,_65._placeholder);
}else{
_62.appendChild(_61);
}
}
this._initialized=true;
this.updateClientState();
this.raise_initialize();
},undock:function(){
var _66=this.get_element();
if(_66.parentNode!=this._form){
this._form.appendChild(_66);
}
var _67=this._getLocation(_66);
this.set_left(_67.x);
this.set_top(_67.y);
var _68=$find(this.get_dockZoneID());
if(_68){
this.set_dockZoneID("");
_68._resetDockIndices();
this._unfitWidth();
}
this._setPinUnpinVisibility();
this.updateClientState();
},_fitWidth:function(){
this.get_element().style.width="100%";
if(this._tableElement){
this.get_innerDockElement().style.width="100%";
this._tableElement.style.width="100%";
this._fixEmWidth();
}
},_unfitWidth:function(){
this.set_width(this.get_width());
if(this._tableElement){
this._fixEmWidth();
}
},_initializeHtmlElementVariables:function(){
this._grip=$get(this.get_id()+"_G");
this._titleBar=$get(this.get_id()+"_T");
if(this._titleBar){
var _69=this._titleBar.lastChild;
while(_69){
if(_69.className=="rdCommands"){
this._commandsContainer=_69;
break;
}
_69=_69.previousSibling;
}
}
var _6a=this.get_element().parentNode;
while(_6a){
if(_6a.tagName.toLowerCase()==="form"){
this._form=_6a;
break;
}
_6a=_6a.parentNode;
}
},_initializeCommands:function(){
if(!this._commandsContainer){
return;
}
var _6b=this._commandsContainer.getElementsByTagName("a");
var _6c=this._commands;
if(_6c){
this._commands={};
for(var i=0;i<_6c.length;i++){
var _6e=_6c[i];
var _6f=eval(_6e.clientTypeName);
if(_6f==Telerik.Web.UI.DockCommand||_6f.inheritsFrom(Telerik.Web.UI.DockCommand)){
_6e.radDock=this;
var _70=null;
if(_6e.command){
_70={"command":eval(_6e.command)};
delete _6e.command;
}
var cmd=$create(_6f,_6e,_70,null,_6b[i]);
this._commands[cmd.get_name()]=cmd;
}else{
throw Error.invalidOperation(_6e.clientTypeName+" does not inherit from Telerik.Web.UI.DockCommand.");
}
}
}
},_updateToggleCommandsState:function(){
var _72=this.getCommand("ExpandCollapse");
if(_72){
_72.set_state(this.get_collapsed()?2:1);
}
var _73=this.getCommand("PinUnpin");
if(_73){
_73.set_state(this.get_pinned()?2:1);
}
},_setPinUnpinVisibility:function(){
var _74=this.getCommand("PinUnpin");
if(_74){
_74.get_element().style.display=this.get_dockZoneID()?"none":"inline";
}
this._setCommandsContainerWidth();
},_setCommandsContainerWidth:function(){
if(!this._commandsContainer){
return;
}
var _75=this._commandsContainer.getElementsByTagName("a");
var _76=0;
for(var i=0;i<_75.length;i++){
var _78=this._getBoundsWithBorderAndMargin(_75[i]);
_76+=_78.width;
}
this._commandsContainer.style.width=_76+"px";
},_getBoundsWithoutBorder:function(_79){
if(!_79){
_79=this.get_element();
}
var _7a=this._getBounds(_79);
var _7b=this._getBorderBox(_79);
var _7c=_7a.width-_7b.horizontal;
var _7d=_7a.height-_7b.vertical;
_7a.width=_7c>0?_7c:0;
_7a.height=_7d>0?_7d:0;
return _7a;
},_getBoundsWithBorderAndMargin:function(_7e){
if(!_7e){
_7e=this.get_element();
}
var _7f=this._getBounds(_7e);
var _80=this._getMarginBox(_7e);
var _81=this._getBorderBox(_7e);
_7f.width+=(($telerik.isSafari?0:_80.horizontal)+_81.horizontal);
_7f.height+=(_80.vertical+_81.vertical);
return _7f;
},_getBounds:function(_82){
if(!_82){
_82=this.get_element();
}
return $telerik.getBounds(_82);
},_getMarginBox:function(_83){
if(!_83){
_83=this.get_element();
}
return $telerik.getMarginBox(_83);
},_getBorderBox:function(_84){
if(!_84){
_84=this.get_element();
}
return $telerik.getBorderBox(_84);
},_resetPosition:function(){
var _85=this.get_element();
_85.style.top="";
_85.style.left="";
_85.originalPosition="relative";
_85.style.position="relative";
_85.style.zIndex=this.originalZIndex;
},_setContentContainerHeight:function(){
var _86=this.get_contentContainer();
if(!_86){
return;
}
if(!Sys.UI.DomElement.containsCssClass(this.get_element(),"rdVariableHeight")||this._resizable){
var _87=this._getBounds();
var _88=this.get_handle();
if(_88&&!this._isCustomHandle){
var _89=this._getBounds(_88);
_87.height-=_89.height;
}
var _8a=this._tableElement?this._calculateResizeHandlesSize().horizontalHeight:2;
var _8b=$telerik.getPaddingBox(_86).vertical;
var _8c=_87.height-_8a-_8b;
_86.style.height=(_8c<0?0:_8c)+"px";
}else{
_86.style.height="";
}
},_restorePosition:function(){
var _8d=$find(this.get_dockZoneID());
if(_8d){
_8d.dock(this,this.get_index());
}else{
this.undock();
}
},_getLocation:function(_8e){
if(!_8e){
_8e=this.get_element();
}
return $telerik.getLocation(_8e);
},_setLocation:function(_8f){
$telerik.setLocation(this.get_element(),_8f);
},_setSize:function(_90,_91){
var _92=this._getBoundsWithoutBorder();
if(!_90){
_90=_92.width;
}
if(!_91){
_91=_92.height;
}
this._setWidthHtmlEl(_90);
this._setHeightHtmlEl(_91);
if(this._tableElement){
this._fixTableLayoutSize(_90,_91);
}else{
this._setContentContainerHeight();
}
},_fixTableLayoutSize:function(_93,_94){
var _95=this.get_contentContainer();
var _96=$telerik.getPaddingBox(_95).vertical;
var _97=this._getTopElement();
var _98={height:0,width:0};
var _99=0;
if(_97){
_98=$telerik.getBounds(_97);
}
var _9a=this.get_innerDockElement();
_9a.style.display="none";
var _9b=this._tableElement;
if(_9b){
this._setHeightHtmlEl(_94,_9b);
this._fixIeHeight(_9b,_94);
}
var _9c=$telerik.getBounds(_9a.parentNode);
var _93=_9c.width;
if(!this._tableElement){
_93-=this._getBorderBox(_9a).horizontal;
}
this._setWidthHtmlEl(_93,_9a);
var _9d=_9c.height-_98.height-_96;
_9d=_9d>0?_9d:0;
this._setHeightHtmlEl(_9d,_95);
if(_9d>0){
_95.style.display="";
}
_9a.style.display="";
this._fixEmWidth();
if(this._collapsed){
_9a.style.height="auto";
}
},get_contentContainer:function(){
if(!this._contentContainer){
this._contentContainer=$get(this.get_id()+"_C");
}
return this._contentContainer;
},get_titleBar:function(){
if(!this._titleBar){
this._titleBar=$get(this.get_id()+"_T");
}
return this._titleBar;
},get_commandsContainer:function(){
if(!this._commandsContainer){
var _9e=this.get_titleBar();
if(_9e){
this._commandsContainer=_9e.getElementsByTagName("span")[0];
}else{
this._commandsContainer=null;
}
}
return this._commandsContainer;
},get_titleElement:function(){
if(!this._titleElement){
var _9f=this.get_titleBar();
this._titleElement=_9f?_9f.getElementsByTagName("em")[0]:null;
}
return this._titleElement;
},get_innerDivElement:function(num){
var _a1=this._tableElement;
if(_a1){
if(_a1.rows.length>1){
var _a2=_a1.rows[1].cells[1];
if(_a2){
return _a2.getElementsByTagName("div")[num];
}
}
}
return this.get_element().getElementsByTagName("div")[num];
},get_innerDockElement:function(){
return this.get_innerDivElement(0);
},get_topBorderElement:function(){
return this.get_innerDivElement(3);
},get_bottomBorderElement:function(){
return this.get_innerDivElement(4);
},saveClientState:function(){
var _a3={Top:this.get_top(),Left:this.get_left(),DockZoneID:this.get_dockZoneID(),Collapsed:this.get_collapsed(),Pinned:this.get_pinned(),Resizable:this.get_resizable(),Closed:this.get_closed(),Width:this.get_width(),Height:this.get_height(),ExpandedHeight:this._expandedHeight,Index:this.get_index()};
return Sys.Serialization.JavaScriptSerializer.serialize(_a3);
},conditionalPostback:function(_a4){
if(this.get_autoPostBack()){
this.doPostBack(_a4);
}
},doPostBack:function(_a5){
__doPostBack(this.get_uniqueID(),_a5);
},add_command:function(_a6){
this.get_events().addHandler("command",_a6);
},remove_command:function(_a7){
this.get_events().removeHandler("command",_a7);
},raise_command:function(_a8){
this.raiseEvent("command",_a8);
},add_dragStart:function(_a9){
this.get_events().addHandler("dragStart",_a9);
},remove_dragStart:function(_aa){
this.get_events().removeHandler("dragStart",_aa);
},raise_dragStart:function(_ab){
this.raiseEvent("dragStart",_ab);
},add_drag:function(_ac){
this.get_events().addHandler("drag",_ac);
},remove_drag:function(_ad){
this.get_events().removeHandler("drag",_ad);
},raise_drag:function(_ae){
this.raiseEvent("drag",_ae);
},add_dragEnd:function(_af){
this.get_events().addHandler("dragEnd",_af);
},remove_dragEnd:function(_b0){
this.get_events().removeHandler("dragEnd",_b0);
},raise_dragEnd:function(_b1){
this.raiseEvent("dragEnd",_b1);
},add_dockPositionChanged:function(_b2){
this.get_events().addHandler("dockPositionChanged",_b2);
},remove_dockPositionChanged:function(_b3){
this.get_events().removeHandler("dockPositionChanged",_b3);
},raise_dockPositionChanged:function(_b4){
this.raiseEvent("dockPositionChanged",_b4);
this.conditionalPostback("dockPositionChanged");
},add_dockPositionChanging:function(_b5){
this.get_events().addHandler("dockPositionChanging",_b5);
},remove_dockPositionChanging:function(_b6){
this.get_events().removeHandler("dockPositionChanging",_b6);
},raise_dockPositionChanging:function(_b7){
this.raiseEvent("dockPositionChanging",_b7);
},add_initialize:function(_b8){
this.get_events().addHandler("initialize",_b8);
},remove_initialize:function(_b9){
this.get_events().removeHandler("initialize",_b9);
},raise_initialize:function(_ba){
this.raiseEvent("initialize",_ba);
},add_resizeStart:function(_bb){
this.get_events().addHandler("resizeStart",_bb);
},remove_resizeStart:function(_bc){
this.get_events().removeHandler("resizeStart",_bc);
},raise_resizeStart:function(_bd){
this.raiseEvent("resizeStart",_bd);
},add_resizeEnd:function(_be){
this.get_events().addHandler("resizeEnd",_be);
},remove_resizeEnd:function(_bf){
this.get_events().removeHandler("resizeEnd",_bf);
},raise_resizeEnd:function(_c0){
this.raiseEvent("resizeEnd",_c0);
},get_top:function(){
return this._top;
},set_top:function(_c1){
if(_c1!=""){
_c1=parseInt(_c1);
if(this._initialized){
this.get_element().style.top=_c1+"px";
}
}
this._top=_c1;
this.updateClientState();
},get_left:function(){
return this._left;
},set_left:function(_c2){
if(_c2!=""){
_c2=parseInt(_c2);
if(this._initialized){
this.get_element().style.left=_c2+"px";
}
}
this._left=_c2;
this.updateClientState();
},get_closed:function(){
return this._closed;
},set_closed:function(_c3){
this._closed=_c3;
var _c4=this.get_element();
_c4.style.display=_c3?"none":"block";
if(!_c3){
this._repaintHelper();
$telerik.repaintChildren(this);
}
},get_collapsed:function(){
return this._collapsed;
},set_collapsed:function(_c5){
this._collapsed=_c5;
_c5?this.get_element().style.height="auto":this._setHeightHtmlEl(this.get_height());
if(this._collapsed){
this._collapseWrapper();
if(this._height){
this._expandedHeight=parseInt(this._height);
}
if(this._resizable){
this.get_innerDockElement().style.height="auto";
}
this._configureHandles(false);
this.addCssClass("rdCollapsed");
}else{
this.removeCssClass("rdCollapsed");
if(this._resizable){
if(this._expandedHeight==0){
this.get_element().style.height="auto";
this._tableElement.style.height="100%";
this.get_contentContainer().style.height="auto";
}
if(!this._dockZoneID){
this._configureHandles(true);
}
this.get_innerDockElement().style.height="";
this._setSize(null,this._expandedHeight);
this._height=this._expandedHeight;
}
if(this.get_height()==null){
this.addCssClass("rdVariableHeight");
}
}
if($telerik.isIE){
setTimeout(Function.createDelegate(this,function(){
this._setContentContainerHeight();
}),0);
}else{
this._setContentContainerHeight();
}
if(!this._collapsed){
$telerik.repaintChildren(this);
}
var _c6=this.getCommand("ExpandCollapse");
if(_c6){
_c6.set_state(_c5?2:1);
}
if(this._resizable){
this._height=$telerik.getBounds(this.get_element()).height+"px";
this.updateClientState();
}
},get_autoPostBack:function(){
return this._autoPostBack;
},set_autoPostBack:function(_c7){
this._autoPostBack=_c7;
},get_commands:function(){
return this._commands;
},set_commands:function(_c8){
this._commands=_c8;
},get_dockMode:function(){
return this._dockMode;
},set_dockMode:function(_c9){
this._dockMode=_c9;
},get_dockZoneID:function(){
return this._dockZoneID;
},set_dockZoneID:function(_ca){
if(_ca==""){
if(!this._collapsed){
this._configureHandles(true);
}
}else{
this._configureHandles(false);
}
this._dockZoneID=_ca;
},get_forbiddenZones:function(){
return this._forbiddenZones;
},set_forbiddenZones:function(_cb){
this._forbiddenZones=_cb;
},get_height:function(){
return this._height;
},set_height:function(_cc){
this._height=_cc;
this.updateClientState();
if(this._initialized){
this._setSize(null,_cc);
if(!this._tableElement){
this.removeCssClass("rdVariableHeight");
}
}
},get_index:function(){
return this._index;
},set_index:function(_cd){
this._index=_cd;
},get_layoutID:function(){
return this._layoutID;
},set_layoutID:function(_ce){
this._layoutID=_ce;
},get_enableDrag:function(){
return this._enableDrag;
},set_enableDrag:function(_cf){
this._enableDrag=_cf;
this._initializeDrag();
},get_pinned:function(){
return this._pinned;
},set_pinned:function(_d0){
this._pinned=_d0;
var _d1=this.getCommand("PinUnpin");
if(_d1){
_d1.set_state(_d0?2:1);
}
if($telerik.isIE6){
if(_d0){
this.set_enableDrag(false);
}else{
this.set_enableDrag(true);
}
return;
}
var _d2=this.get_element();
_d2.style.position="absolute";
var _d3=$telerik.getScrollOffset(_d2,true);
var _d4=this._getLocation(_d2);
if(_d0){
_d4=this.subtractPoints(_d4,_d3);
this._setLocation(_d4);
_d2.style.position="fixed";
this.set_enableDrag(false);
}else{
_d4=this.addPoints(_d4,_d3);
this._setLocation(_d4);
this.set_enableDrag(true);
}
},get_title:function(){
return this._title;
},set_title:function(_d5){
this._title=_d5;
var _d6=this.get_titleElement();
if(_d6){
_d6.innerHTML=_d5;
}
},get_uniqueID:function(){
return this._uniqueID;
},set_uniqueID:function(_d7){
this._uniqueID=_d7;
},get_uniqueName:function(){
return this._uniqueName;
},set_uniqueName:function(_d8){
this._uniqueName=_d8;
},get_width:function(){
return this._width;
},set_width:function(_d9){
this._width=_d9;
this.updateClientState();
if(this._initialized){
this._setSize(_d9,null);
}
},get_skin:function(){
return this._skin;
},set_skin:function(_da){
if(_da&&this._skin!=_da){
this._skin=_da;
}
},get_resizable:function(){
return this._resizable;
},set_resizable:function(_db){
this._resizable=_db;
if(_db){
this._makeResizable();
}else{
this._removeWrapper();
}
},get_dockZone:function(){
return this._dockZone;
},set_dockZone:function(_dc){
this._dockZone=_dc;
}};
Telerik.Web.UI.RadDock.registerClass("Telerik.Web.UI.RadDock",Telerik.Web.UI.RadWebControl);
Telerik.Web.UI.RadDock.prototype.repaint=function(){
this._repaintHelper();
};
Telerik.Web.UI.DockCommand=function(_dd){
Telerik.Web.UI.DockCommand.initializeBase(this,[_dd]);
this._clientTypeName=null;
this._cssClass="rdCustom";
this._radDock=null;
this._name="Custom";
this._text="Custom";
this._autoPostBack=false;
};
Telerik.Web.UI.DockCommand.prototype={add_command:function(_de){
this.get_events().addHandler("command",_de);
},remove_command:function(_df){
this.get_events().removeHandler("command",_df);
},raise_command:function(_e0){
var _e1=this.get_events().getHandler("command");
if(_e1){
_e1(this.get_radDock(),_e0);
}
},get_clientTypeName:function(){
return this._clientTypeName;
},set_clientTypeName:function(_e2){
this._clientTypeName=_e2;
},get_cssClass:function(){
return this._cssClass;
},set_cssClass:function(_e3){
this._cssClass=_e3;
},get_name:function(){
return this._name;
},set_name:function(_e4){
this._name=_e4;
},get_text:function(){
return this._text;
},set_text:function(_e5){
this._text=_e5;
},get_autoPostBack:function(){
return this._autoPostBack;
},set_autoPostBack:function(_e6){
this._autoPostBack=_e6;
},get_radDock:function(){
return this._radDock;
},set_radDock:function(_e7){
this._radDock=_e7;
},onCommand:function(e){
var _e9=new Sys.CancelEventArgs();
_e9.command=this;
_e9.event=e;
_e9.Command=this;
this.raise_command(_e9);
if(_e9.get_cancel()){
return;
}
this.get_radDock().raise_command(_e9);
if(_e9.get_cancel()){
return;
}
this.get_radDock().updateClientState();
this.conditionalPostback();
},onMouseDown:function(e){
$telerik.cancelRawEvent(e);
},conditionalPostback:function(){
if(this.get_autoPostBack()){
this.get_radDock().doPostBack(this.get_name());
}
},initialize:function(){
Telerik.Web.UI.DockCommand.callBaseMethod(this,"initialize");
$addHandlers(this.get_element(),{"click":this.onCommand,"mousedown":this.onMouseDown},this);
},dispose:function(){
$clearHandlers(this.get_element());
Telerik.Web.UI.DockCommand.callBaseMethod(this,"dispose");
}};
Telerik.Web.UI.DockCommand.registerClass("Telerik.Web.UI.DockCommand",Sys.UI.Control);
Telerik.Web.UI.DockToggleCommand=function(_eb){
Telerik.Web.UI.DockToggleCommand.initializeBase(this,[_eb]);
this._state=1;
this._alternateCssClass="rdCustom";
this._alternateText="Custom";
this._initialSetState=false;
};
Telerik.Web.UI.DockToggleCommand.prototype={updateState:function(){
var _ec=this.get_element();
if(this.get_state()==1){
_ec.title=this.get_text();
Sys.UI.DomElement.addCssClass(_ec,this.get_cssClass());
Sys.UI.DomElement.removeCssClass(_ec,this.get_alternateCssClass());
}else{
_ec.title=this.get_alternateText();
Sys.UI.DomElement.addCssClass(_ec,this.get_alternateCssClass());
Sys.UI.DomElement.removeCssClass(_ec,this.get_cssClass());
}
},get_state:function(){
return this._state;
},set_state:function(_ed){
this._state=_ed;
if(this._initialSetState){
this.updateState();
}
},get_alternateCssClass:function(){
return this._alternateCssClass;
},set_alternateCssClass:function(_ee){
this._alternateCssClass=_ee;
},get_alternateText:function(){
return this._alternateText;
},set_alternateText:function(_ef){
this._alternateText=_ef;
},initialize:function(){
Telerik.Web.UI.DockToggleCommand.callBaseMethod(this,"initialize");
this._initialSetState=true;
this.updateState();
},dispose:function(){
Telerik.Web.UI.DockToggleCommand.callBaseMethod(this,"dispose");
}};
Telerik.Web.UI.DockToggleCommand.registerClass("Telerik.Web.UI.DockToggleCommand",Telerik.Web.UI.DockCommand);
Telerik.Web.UI.DockCloseCommand=function(_f0){
Telerik.Web.UI.DockCloseCommand.initializeBase(this,[_f0]);
this._cssClass="rdClose";
this._name="Close";
this._text="Close";
};
Telerik.Web.UI.DockCloseCommand.prototype={onCommand:function(e){
this.get_radDock().set_closed(true);
Telerik.Web.UI.DockCloseCommand.callBaseMethod(this,"onCommand");
}};
Telerik.Web.UI.DockCloseCommand.registerClass("Telerik.Web.UI.DockCloseCommand",Telerik.Web.UI.DockCommand);
Telerik.Web.UI.DockExpandCollapseCommand=function(_f2){
Telerik.Web.UI.DockExpandCollapseCommand.initializeBase(this,[_f2]);
this._cssClass="rdCollapse";
this._alternateCssClass="rdExpand";
this._name="ExpandCollapse";
this._text="Collapse";
this._alternateText="Expand";
};
Telerik.Web.UI.DockExpandCollapseCommand.prototype={onCommand:function(e){
this.get_radDock().set_collapsed(!this.get_radDock().get_collapsed());
Telerik.Web.UI.DockExpandCollapseCommand.callBaseMethod(this,"onCommand");
}};
Telerik.Web.UI.DockExpandCollapseCommand.registerClass("Telerik.Web.UI.DockExpandCollapseCommand",Telerik.Web.UI.DockToggleCommand);
Telerik.Web.UI.DockPinUnpinCommand=function(_f4){
Telerik.Web.UI.DockPinUnpinCommand.initializeBase(this,[_f4]);
this._cssClass="rdUnpin";
this._alternateCssClass="rdPin";
this._name="PinUnpin";
this._text="Pin";
this._alternateText="Unpin";
};
Telerik.Web.UI.DockPinUnpinCommand.prototype={onCommand:function(e){
this.get_radDock().set_pinned(!this.get_radDock().get_pinned());
Telerik.Web.UI.DockPinUnpinCommand.callBaseMethod(this,"onCommand");
}};
Telerik.Web.UI.DockPinUnpinCommand.registerClass("Telerik.Web.UI.DockPinUnpinCommand",Telerik.Web.UI.DockToggleCommand);

